blog/urls.py
from django.conf.urls import url
from blog import views

app_name = 'blog'

urlpatterns = [

    url('about/', views.AboutView.as_view(), name='about'),
    url('post/new/', views.CreatePostView.as_view(), name='post_new'),
    url('post/<int:pk>', views.PostDetailView.as_view(), name='post-detail'),
    url('post/<int:pk>/edit/', views.PostUpdateView.as_view(), name='post_edit'),
    url('post/<int:pk>/remove', views.PostDeleteView.as_view(), name='post_remove'),
    url('post/<int:pk>/publish', views.post_publish, name='post_publish'),
    url('drafts/', views.DraftListView.as_view(), name='post_draft_list'),
    url('post/<int:pk>/comment/', views.add_comment_to_post, name='add_comment_to_post'),
    url('comment/<int:pk>/approve/', views.comment_approve, name='comment_approve'),
    url('comment/<int:pk>/remove/', views.comment_remove, name='comment_remove'),

    url('', views.PostListView.as_view(), name='post_list'),
]

blog_project/urls.py
from django.contrib import admin
from django.contrib.auth.views import LoginView, LogoutView
from django.conf.urls import url
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),

    url('accounts/login/', LoginView.as_view(), name='login'),
    url('accounts/logout/', LogoutView.as_view(), name='logout', kwargs={'next_page': '/'}),

    path('', include('blog.urls', namespace='blog')),
]

blog/models.py
from django.db import models
from django.utils import timezone
from django.urls.base import reverse


class Post(models.Model):
    author = models.ForeignKey('auth.User', on_delete=models.CASCADE)
    title = models.CharField(max_length=200)
    text = models.TextField()
    create_date = models.DateTimeField(default=timezone.now)
    published_date = models.DateTimeField(blank=True, null=True)

    def publish(self):
        self.published_date = timezone.now()
        self.save()

    def approve_comments(self):
        return self.comments.filter(approved_comments=True)

    def get_absolute_url(self):
        return reverse('blog:post-detail', kwargs={"pk": self.pk})

    def __str__(self):
        return self.title


class Comment(models.Model):
    post = models.ForeignKey('blog.Post', related_name='comments', on_delete=models.CASCADE)
    author = models.CharField(max_length=256)
    text = models.TextField()
    create_date = models.DateTimeField(default=timezone.now)
    approved_comment = models.BooleanField(default=False)

    def approve(self):
        self.approved_comment = True
        self.save()

    def get_absolute_url(self):
        return reverse('blog:post_list')

    def __str__(self):
        return self.text

blog/forms.py
from django import forms
from blog.models import Post, Comment


class PostForm(forms.ModelForm):

    class Meta:
        model = Post
        fields = ('author', 'title', 'text')

        widgets = {
            'title': forms.TextInput(attrs={'class': 'textinputclass'}),
            'text': forms.Textarea(attrs={'class': 'editable medium-editor-textarea postcontent'})
        }


class CommentForm(forms.ModelForm):

    class Meta:
        model = Comment
        fields = ('author', 'text')

        widgets = {
            'author': forms.TextInput(attrs={'class': 'textinputclass'}),
            'text': forms.Textarea(attrs={'class': 'editable medium-editor-textarea'})
        }

blog/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.urls import reverse_lazy
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.decorators import login_required
from blog.models import Post, Comment
from blog.forms import PostForm, CommentForm
from django.views.generic import (TemplateView, ListView, DetailView, CreateView, UpdateView, DeleteView)
from django.utils import timezone


class AboutView(TemplateView):
    template_name = 'blog/about.html'


class PostListView(ListView):
    model = Post

    def get_queryset(self):
        return Post.objects.filter(published_date__lte=timezone.now()).order_by('-published_date')


class PostDetailView(DetailView):
    model = Post


class CreatePostView(LoginRequiredMixin, CreateView):
    login_url = '/login/'  # Require field for LoginRequiedMixing
    redirect_field_name = 'blog/post_detail.html'  # Require field for LoginRequiedMixing
    form_class = PostForm  # Require for CreateView
    model = Post  # Require for CreateView


class PostUpdateView(LoginRequiredMixin, UpdateView):
    login_url = '/login/'
    redirect_field_name = 'blog/post_detail.html'
    form_class = PostForm
    model = Post


class PostDeleteView(LoginRequiredMixin, DeleteView):
    model = Post
    success_url = reverse_lazy('blog:post_list')


class DraftListView(LoginRequiredMixin, ListView):
    login_url = '/login/'
    redirect_field_name = 'blog/post_draft_list.html'
    model = Post

    def get_queryset(self):
        return Post.objects.filter(published_date__isnull=True).order_by('create_date')


# ---------- Comments ------------ ##

@login_required
def post_publish(request, pk):
    post = get_object_or_404(Post, pk=pk)
    post.publish()
    return redirect('blog:post-detail', pk=pk)


@login_required
def add_comment_to_post(request, pk):
    post = get_object_or_404(Post, pk=pk)
    if request.method == 'POST':
        form = CommentForm(request.POST)
        if form.is_valid():
            comment = form.save(commit=False)
            comment.post = post  # ForeignKey from Comment Model is equal to the post object,
            # we are connecting comment to post.
            comment.save()
            return redirect('blog:post-detail', pk=post.pk)
    else:
        form = CommentForm()
    return render(request, 'blog/comment_form.html', {'form': form})


@login_required
def comment_approve(request, pk):
    comment = get_object_or_404(Comment, pk=pk)
    comment.approve()
    return redirect('blog:post-detail', pk=comment.post.pk)


@login_required
def comment_remove(request, pk):
    comment = get_object_or_404(Comment, pk=pk)
    post_pk = comment.post.pk  # We setup the pk of the post to remember where to go after deleting the comment.
    comment.delete()
    return redirect('blog:post-detail', pk=post_pk)

blog/templates/blog/about.html
{% extends 'blog/base.html' %}

{% block content %}
    <h1>About me</h1>
    <p>My name is Carlos and I'm learning this thing call programming with Django framework.</p>
{% endblock %}

blog/templates/blog/base.html
<!DOCTYPE html>
{% load staticfiles %}
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Blog</title>

    <!-- Bootstrap -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>

    <!-- Medium Style Editor -->
    <script src="//cdn.jsdelivr.net/npm/medium-editor@latest/dist/js/medium-editor.min.js"></script>
    <link rel="stylesheet" href="//cdn.jsdelivr.net/npm/medium-editor@latest/dist/css/medium-editor.min.css" type="text/css" media="screen" charset="utf-8">

    <!-- Custom CSS -->
    <link rel="stylesheet" href="{% static 'css/blog.css' %}">

    <!-- fonts -->
    <link href="https://fonts.googleapis.com/css?family=Montserrat|Roboto" rel="stylesheet">

    <!-- fontawesome icons -->
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css" integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU" crossorigin="anonymous">

</head>
<body>

    <!-- NavBar -->
    <nav class="navbar navbar-expand-lg bg-light robotofont">
        <div class="container">
            <div class="navbar-nav align-items-center">
                <a class="navbar-brand" href="{% url 'blog:post_list' %}">Blog</a>
                <a class="nav-item nav-link" href="{% url 'blog:about' %}">About</a>
                <a class="nav-item nav-link" href="https://about.gitlab.com">GitLab</a>
                <a class="nav-item nav-link" href="https://getbootstrap.com">Bootstrap</a>
            </div>
            <div class="navbar-nav align-items-center ml-auto">
                {% if user.is_authenticated %}
                    <a class="nav-item nav-link" href="{% url 'blog:post_new' %}">New Post</a>
                    <a class="nav-item nav-link" href="{% url 'blog:post_draft_list' %}">Drafts</a>
                    <a class="nav-item nav-link" href="{% url 'logout' %}">Log out</a>
                    <a>Welcome {{ user.username }}</a>
                    {% else %}
                    <a class="nav-item nav-link" href="{% url 'login' %}"><i class="fas fa-sign-in-alt"></i></a>
                {% endif %}
            </div>
        </div>
    </nav>

    <!-- Content Blog -->
    <div class="content container">
        <div class="row">
            <div class="col-md-8">
                <div class="blog_posts">
                    {% block content %}
                    {% endblock %}
                </div>
            </div>
        </div>
    </div>

</body>
</html>

blog/templates/blog/comment_form.html
{% extends "blog/base.html" %}

{% block content %}
    <h1>New Comment</h1>
    <form method="post">
     {% csrf_token %}
        {{ form.as_p }}
        <button type="submit" class="btn btn-success">Post Comment</button>
    </form>

    <script>var editor = new MediumEditor('.editable');</script>
    
{% endblock %}

blog/templates/blog/post_confirm_delete.html
{% extends "blog/base.html" %}

{% block content %}
    <form method="post">
        {% csrf_token %}
            <p>Are you sure you want to delete {{ object }}</p>
            <input type="submit" class="btn btn-danger" value="Confirm">
    </form>
    
{% endblock %}

blog/templates/blog/post_detail.html
{% extends 'blog/base.html' %}

{% block content %}
    <h1 class="posttitle">{{ post.title }}</h1>
    {% if post.published_date %}
        <div class="date postdate">
        {{ post.published_date }}
        </div>
    {% else %}
        <a class="btn btn-default" href="{% url 'blog:post_publish' pk=post.pk %}">Publish</a>
    {% endif %}

    <p class="postcontent">{{ post.text|safe|linebreaksbr }}</p>

    {% if user.is_authenticated %}
        <a class="btn btn-primary" href="{% url 'blog:post_edit' pk=post.pk %}"><span class="glyphicon glyphicon-pencil"></span></a>
        <a class="btn btn-danger" href="{% url 'blog:post_remove' pk=post.pk %}"><span class="glyphicon glyphicon-remove"></span></a>
    {% endif %}

    <hr>

    <a class="btn btn-primary" href="{% url 'blog:add_comment_to_post' pk=post.pk %}">Add comment</a>

    <div class="container">
        {% for comment in post.comments.all %}
            <br>
            {% if user.is_authenticated or comment.approved_comment %}
                {{ comment.create_date }}
                {% if not comment.approved_comment %}
                    <a class="btn btn-success" href="{% url 'blog:comment_approve' pk=comment.pk %}"><span class="glyphicon glyphicon-pencil"></span></a>
                    <a class="btn btn-danger" href="{% url 'blog:comment_remove' pk=comment.pk %}"><span class="glyphicon glyphicon-remove"></span></a>
                {% endif %}
                <p>{{ comment.text|safe|linebreaks }}</p>
                <p>Posted by: {{ comment.author }}</p>
            {% endif %}
            {% empty %}
            <p>No comments!</p>
        {% endfor %}
    </div>
{% endblock %}

blog/templates/blog/post_draft_list.html
{% extends "blog/base.html" %}

{% block content %}
    {% for post in posts %}
        <div>
            <p class="date">created: {{ post.create_date|date:"d-M-Y" }}</p>
            <h1><a href="{% url 'blog:post-detail' pk=post.pk %}">{{ post.title }}</a> </h1>
            <p>{{ post.text|truncatechars:200 }}</p>
        </div>
    {% endfor %}
    
{% endblock %}

blog/templates/blog/post_form.html
{% extends "blog/base.html" %}

{% block content %}
    <h1>New Post</h1>
    <form class="post-form" method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit" class="btn btn-primary" name="button">Save</button>
    </form>
    <script>
        var editor = new MediumEditor('.editable');
    </script>
{% endblock %}

blog/templates/blog/post_list.html
{% extends "blog/base.html" %}

{% block content %}
    <div class="centerstage">
        {% for post in post_list %}
            <div class="post">
                <h1><a href="{% url 'blog:post-detail' pk=post.pk %}">{{ post.title }}</a></h1>
                <div class="date">
                    <p>Published on: {{ post.published|date:"d-M-Y" }}</p>
                </div>
                <a href="{% url 'blog:post-detail' pk=post.pk %}">Comments: {{ post.approved_comments.count }}</a>
            </div>
        {% endfor %}
    </div>
{% endblock %}